describe('Initial states: ', function() {
  it('is #group1 focused?', function() {
    expect($('#group1')).toBe('.focus');
  });
  it('is #group2 focused?', function() {
    expect($('#group2')).toBe('.focus');
  });
  it('is #button1 focused?', function() {
    expect($('#button1')).toBe('.focus');
    expect(document.activeElement).toBe($('#button1')[0]);
  });
  it('are these the only focused elements?', function() {
    expect($('#focusController-test .focus').length).toBe(3);
  });
});

describe('Move within group1: ', function() {
  it('move to button2', function() {
    var rightEvent = new $.Event('keydown');
    rightEvent.which = KEY_CODES.RIGHT_ARROW[0];

    $(document.activeElement).trigger(rightEvent);
    expect($('#button1')).not.toBe('.focus');
    expect($('#button2')).toBe('.focus');
    expect(document.activeElement).toBe($('#button2')[0]);
  });

  it('move to button4', function() {
    var downEvent = new $.Event('keydown');
    downEvent.which = KEY_CODES.DOWN_ARROW[0];

    $(document.activeElement).trigger(downEvent);
    expect($('#button2')).not.toBe('.focus');
    expect($('#button4')).toBe('.focus');
    expect(document.activeElement).toBe($('#button4')[0]);
  });
});

describe('Move between group1 and group2: ', function() {
  it('move to button5', function() {
    var rightEvent = new $.Event('keydown');
    rightEvent.which = KEY_CODES.RIGHT_ARROW[0];

    $(document.activeElement).trigger(rightEvent);
    expect($('#button4')).not.toBe('.focus');
    expect($('#button5').parent()).toBe('.focus');
    expect(document.activeElement).toBe($('#button5')[0]);
    expect($('#group2')).not.toBe('.focus');
    expect($('#group3')).toBe('.focus');
  });

  it('move to button6', function() {
    var rightEvent = new $.Event('keydown');
    rightEvent.which = KEY_CODES.RIGHT_ARROW[0];

    $(document.activeElement).trigger(rightEvent);
    expect($('#button5').parent()).not.toBe('.focus');
    expect($('#button6')).toBe('.focus');
    expect(document.activeElement).toBe($('#button6')[0]);
  });

  it('invalid move', function() {
    var rightEvent = new $.Event('keydown');
    rightEvent.which = KEY_CODES.RIGHT_ARROW[0];

    $(document.activeElement).trigger(rightEvent);
    expect($('#button6')).toBe('.focus');
    expect(document.activeElement).toBe($('#button6')[0]);
  });
});

describe('Click events: ', function() {
  it('click on button5', function() {
    var clickEvent = new $.Event('click');

    $('#button5').trigger(clickEvent);
    expect($('#button6')).not.toBe('.focus');
    expect($('#button5').parent()).toBe('.focus');
    expect(document.activeElement).toBe($('#button5')[0]);
  });

  it('click on button1', function() {
    var clickEvent = new $.Event('click');

    $('#button1').trigger(clickEvent);
    expect($('#button1')).toBe('.focus');
    expect(document.activeElement).toBe($('#button1')[0]);
    expect($('#button5').parent()).not.toBe('.focus');
    expect($('#group3')).not.toBe('.focus');
    expect($('#group2')).toBe('.focus');
    expect($('#group1')).toBe('.focus');
  });
});
