TS.Modules.head  = {
  moduleName: 'head',
  // CONFIG
  config: {},
  autoInit: true,
  focusGraph: null,
  requires: ['navigationController', 'focusController'],
  init: function(){
    
    // loadCss(TS.Config.Path.Style + 'head.css');
    
    var view = new View(loadTemplate(TS.Config.Path.Modules + this.moduleName + '/' + this.moduleName + TS.Config.templateSuffix), '#section-header');
    view.set('liveMatchCentre', $.translate('head_menu_live_match_centre'));
    view.set('news', $.translate('head_menu_news'));
    view.set('videos', $.translate('head_menu_videos'));
    view.set('home', $.translate('head_menu_home'));
    view.set('back', $.translate('head_menu_back'));
    
    view.display().show();

    $('#goto-Back').on('click', function() {
      var event = new $.Event('keydown');
      event.which = TS.KeyCodes.back;
      $(document.activeElement).trigger(event);
    });
    
    TS.Modules.head.focusGraph = new TS.Modules.focusController.FocusGraph().setElement($('#head-Menu'));
    
    TS.Modules.head.focusGraph.setMap({
        initial: 'home',
        home:   {element: $('#goto-Home'), right: 'videos'},
        videos: {element: $('#goto-Videos'), right: 'news', left: 'home'},
        news:   {element: $('#goto-News'), right: 'lmc', left: 'videos'},
        lmc:    {element: $('#goto-Live-Match-Centre'), left: 'news'}
    }).blur();

    $('#head-Menu li a').click(function(){
      if($(this).hasClass('active')){
        return false;
      }
      //$('#head-Menu li a').removeClass('active');
      //$(this).addClass('active');
      TS.Modules.navigationController.root.navigate($(this).attr('head-navigate'));
      TS.Config.history.push($(this).attr('head-navigate'));
    }).filter('#goto-Home');

    $(TS.Modules.navigationController.root).on('childOpen', function(event, data) {
      var url = data.url,
          item = $('#goto-Home');

      var map = TS.Modules.head.focusGraph.map;

      // show/hide back button
      if (url.length > 1 && url!='/home') {
        $('#goto-Back').parent().show();
        map.lmc.right = 'back';
        map.back = {element: $('#goto-Back'), left: 'lmc'};
      } else {
        $('#goto-Back').parent().hide();
        map.lmc.right = undefined;
      }

      $('#head-Menu a').removeClass('active');
      if (url.indexOf('news') !== -1) 
        item = $('#goto-News');
      else if (url.indexOf('videos') !== -1) 
        item = $('#goto-Videos');
      else if (url.indexOf('livematchcentre') !== -1) 
        item = $('#goto-Live-Match-Centre');

      TS.Modules.head.focusGraph.setFocused(item.addClass('active'));
    });

    // TEST ALERT DIALOG
    if(TS.Config.DEBUG){
      $('#logo').unbind('click');
      $('#logo').bind('click', function(){
        var testAlert = {
          title: 'We are sorry',
          text: 'But there has been an error during the load of the application. You can wait for the app to respond or you can restart the application.',
          yesButton: {
            buttonLabel: 'Restart app',
            callback: function(){
              location.reload();
            }
          },
          noButton: {
            buttonLabel: 'Wait',
            callback: false
          }
        };
        TS.Modules.noticeWindow.alert(testAlert);
      });
    }

    $.trace.info('Module: '+ this.moduleName +' [OK]');
  }
};
