TS.Modules.index  = {
  moduleName: 'index',
  // CONFIG
  config: {},
	requires: ['head', 'home', 'videosPage', 'news', 'livematchcentre', 
             'focusController', 'navigationController', 'goalFeeds'],
  autoInit: true,
  
  init: function(){
    // delay init until feeds are ready
    if (!TS.Modules.goalFeeds.isReady) {
      $(TS.Modules.goalFeeds).on('ready', this.init.bind(this));
      return;
    }

    // init videoTracker

    if (videoTracker) {
      if (TS.Config.geolocation) {
        TS.Config.VideoTracker.omnitureTracker.language = TS.Config.lang();
        TS.Config.VideoTracker.omnitureTracker.country = TS.Config.edition();
      }
      videoTracker.init(TS.Config.VideoTracker);
      $.trace.log('videoTracker initialised: ' + JSON.stringify(TS.Config.VideoTracker));
    } else {
      $.trace.warn('Didn\'t set up video tracking.');
    } 

    TS.Modules.navigationController.root.addChildren(
      TS.Modules.home.navigator,
      TS.Modules.livematchcentre.navigator,
      TS.Modules.news.navigator,
      TS.Modules.videosPage.navigator
    );
    TS.Modules.navigationController.root.setDefault(TS.Modules.home.navigator);

    TS.Modules.focusController.root.setMap({
      head: {
        element: TS.Modules.head.focusGraph,
        down: 'content'
      },
      content: {
        up: 'head',
        element: TS.Modules.home.focusGraph
      },
      initial: 'content'
    }).focus();

    TS.Modules.navigationController.root.navigate('/');
  }
};
