TS.Modules.tables = {
	moduleName : 'tables',
	autoInit : true,
	config: {},
	focusGraph: null,
  requires: ['goalFeeds'],
	navigator: null,
	init : function(){

    if (!TS.Modules.goalFeeds.isReady) {
      $(TS.Modules.goalFeeds).on('ready', this.init.bind(this));
      return;
    }

		// loadCss(TS.Config.Path.Style + 'tables.css');
		var view = new View(loadTemplate(TS.Config.Path.Modules + this.moduleName + '/' + this.moduleName + TS.Config.templateSuffix), '#section-lmc-content'),
		    viewRef = 0;
		
		this.feedHandler = TS.Modules.goalFeeds.tablesFeed;
		
		$('#section-lmc-content').html('');
		
		this.navigator = new TS.Modules.navigationController.Navigator('tables',this);
		this.focusGraph = new TS.Modules.focusController.FocusGraph();
    var map;
    
    var show = function(event, data) {
      TS.Modules.livematchcentre.isLMC = false;
      // init textfields
      // header textfields
      view.set('table_team_name_label', $.translate('table_team_name_label'));
      view.set('table_p_label', $.translate('table_p_label') );
      view.set('table_w_label', $.translate('table_w_label') );
      view.set('table_d_label', $.translate('table_d_label'));
      view.set('table_L_label', $.translate('table_L_label'));
      view.set('table_gd_label', $.translate('table_gd_label'));
      view.set('table_pts_label', $.translate('table_pts_label'));
      viewRef = view.display();
		  map = {
        initial: 'down',
        up : {
          element: $('.buttons .sprite-lmc-tables-scrollup',viewRef),
          down : 'down'
        },
        down : {
          element: $('.buttons .sprite-lmc-tables-scrolldown',viewRef),
          up : null
        }
      }
			this.focusGraph.setElement(viewRef).setMap(map);
			TS.Modules.livematchcentre.focusGraph.changeElement('content',this.focusGraph);

			this.feedHandler.pull({competitionID:TS.Modules.livematchcentre.competitionID});
    }.bind(this);


		var feedReady = function(e,response){
		
			var processRow = function(data,position){
				var item = [];
				for(var i in data)
					item.push({key:i,value:data[i]});
				
				item.push({key:'_position',value:position});
				return item;
			};
			
			var items = [];
			for(var i=0; i < response.processedResponse.results.length; i++)
			{
				items.push(processRow(response.processedResponse.results[i],i+1))
			}

			view.foreach(items, '#LMCtableRows');
      $(viewRef).show();
			
			$('.buttons .sprite-lmc-tables-scrollup',viewRef).override('click','scroll',function(){
				$('#LMC_table')[0].scrollTop -= 50;
			});
			$('.buttons .sprite-lmc-tables-scrolldown',viewRef).override('click','scroll',function(){
				$('#LMC_table')[0].scrollTop += 50;
			});

			// mousewheel handling
			$('#LMC_table').override('mousewheel wheel','scroll',function(e){
				$('#LMC_table')[0].scrollTop -= e.originalEvent.wheelDeltaY > 0 ? 50 : -50;
			});
			
			// up/down arrows disabled/enabled settings
			 var downArrow = $('#livematchcentre-tables .down');
			 var upArrow = $('#livematchcentre-tables .up');
			 upArrow.addClass('disabled');

			 $('#LMC_table').scroll(function(){

  			   //up
  			   if($('#LMC_table')[0].scrollTop == 0){
  			     upArrow.addClass('disabled'); 
  			     map.down.up = null;
  			     map.initial = 'down';
  			   }
  			   else{
  			     upArrow.removeClass('disabled'); 
  			      map.down.up = 'up';
  			      map.initial = 'up'
  			   }
  			  
  			  //down
  			   var max = $('#LMC_table')[0].scrollHeight - $('#LMC_table').height(); 
  			   if($('#LMC_table')[0].scrollTop >= max){
  			     downArrow.addClass('disabled'); 
  			     map.up.down = null;
  			     map.initial = 'up';
  			   }
  			   else{
  			     downArrow.removeClass('disabled'); 
  			      map.up.down = 'down';
  			      map.initial = 'down';
  			   }
			  
			  });

			$(this).trigger('ready');
		}.bind(this);
		$(this.feedHandler).on('ready change',feedReady);
		$(this.feedHandler).override("error","tablesErrorHandler",function(){$(this).trigger('error')}.bind(this));

		

    var hide = function(event, data) {
      $('#section-lmc-content').html('');
      $(this.feedHandler).override("error","tablesErrorHandler");
    }

    $(this.navigator).on('open', show);
    $(this.navigator).on('close', hide);
	}
}

