// CASPER+3

TS.init = function(){
  $.trace.time('INIT: ');
  $.trace.warn('-------------------- > Current Version: ' + TS.version);
  TS.currentLang = TS.Config.lang();
  TS.currentEdition = TS.Config.edition();
  TS.currentFeedSource = TS.Config.feedSource();

  Preloader.show();


  if(!$.trace.isConsoleAvailable){
    window.onerror = function(message, url, linenumber) {
      $.trace.error(message + '<span style="color:#fff"> IN "' + url + '" @ LINE ' + linenumber+'</span>');
    }
  }

  $.trace.info('Running with ' + TS.Platform.name + ' profile.');
  if(hasStorage){$.trace.info('HTML5 Local Storage Available');}
  else{$.trace.warn('HTML5 Local Storage Not present');}
  
  
  TS.hashes = $.getHash();
    if(typeof(TS.hashes.view)!=='string' || TS.hashes.view===''){
      TS.hashes.view = 'home';
    }
  
  // Load available modules
  $.trace.group('Module Responses:');
  for(var i=0; i<TS.Include.length; i++){
    loadScripts(TS.Config.Path.Modules+TS.Include[i]+'/'+TS.Include[i]+TS.Config.controllerSuffix);
    TS.modulesLength = i+1;
  }
  $.trace.info('ALl Modules Loaded:');
  
  var modules2load = TS.modulesLength;
  
  $.trace.warn('AUTOINIT START');
  
  $(TS).on('moduleReady', function(){
    modules2load--;
    if(modules2load<=0){
      // Autoinit available modules
      for(var i = 0; i < TS.Include.length; i++){
				if(!TS.initModule(TS.Modules[TS.Include[i]]))
				{
					modules2load+=TS.initModule.dependencies;
					return false;
				}
      }
      
     Preloader.hide();
  
      $.trace.info('TS Status: ONLINE');
      $(TS).trigger('ready');
      $.trace.timeEnd('INIT: ');
      $.trace.warn('AUTOINIT END');
      
      var endTime = microtime(true);
      $.trace.info('LOAD TIME: ' + (endTime - TS.startTime));
    }
  });
  $.trace.groupEnd();
};
